/* A Bison parser, made by GNU Bison 2.1.  */

/* C++ Skeleton parser for LALR(1) parsing with Bison,
   Copyright (C) 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

// Take the name prefix into account.
#define yylex   velex

#include "ValueExpressionParser.tab.hh"

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* A pseudo ostream that takes yydebug_ into account. */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

/* Enable debugging if requested.  */
#if YYDEBUG

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << (Title) << ' ';			\
      yysymprint_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (0)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yyreduce_print_ (Rule);		\
} while (0)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (0)

#else /* !YYDEBUG */

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

#if YYERROR_VERBOSE

/* Return YYSTR after stripping away unnecessary quotes and
   backslashes, so that it's suitable for yyerror.  The heuristic is
   that double-quoting is unnecessary unless the string contains an
   apostrophe, a comma, or backslash (other than backslash-backslash).
   YYSTR is taken from yytname.  */
std::string
yy::ValueExpressionParser::yytnamerr_ (const char *yystr)
{
  if (*yystr == '"')
    {
      std::string yyr = "";
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    yyr += *yyp;
	    break;

	  case '"':
	    return yyr;
	  }
    do_not_strip_quotes: ;
    }

  return yystr;
}

#endif

#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

void
yy::ValueExpressionParser::yysymprint_ (int yytype,
                         const semantic_type* yyvaluep, const location_type* yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;
  /* Backward compatibility, but should be removed eventually. */
  std::ostream& cdebug_ = *yycdebug_;
  (void) cdebug_;

  *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	     << ' ' << yytname_[yytype] << " ("
             << *yylocationp << ": ";
  switch (yytype)
    {
      case 3: /* "\"scalarID\"" */
#line 90 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->name); };
#line 146 "ValueExpressionParser.tab.cc"
        break;
      case 4: /* "\"vectorID\"" */
#line 90 "ValueExpressionParser.yy"
        { debug_stream () << *(yyvaluep->vname); };
#line 151 "ValueExpressionParser.tab.cc"
        break;
      case 5: /* "\"number\"" */
#line 93 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->val); };
#line 156 "ValueExpressionParser.tab.cc"
        break;
      case 6: /* "\"vector\"" */
#line 91 "ValueExpressionParser.yy"
        { Foam::OStringStream buff; buff << *(yyvaluep->vec); debug_stream () << buff.str().c_str(); };
#line 161 "ValueExpressionParser.tab.cc"
        break;
      case 7: /* "\"expression\"" */
#line 94 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->sfield)->name().c_str(); };
#line 166 "ValueExpressionParser.tab.cc"
        break;
      case 8: /* "\"lexpression\"" */
#line 94 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->sfield)->name().c_str(); };
#line 171 "ValueExpressionParser.tab.cc"
        break;
      case 9: /* "\"vexpression\"" */
#line 94 "ValueExpressionParser.yy"
        { debug_stream () << (yyvaluep->vfield)->name().c_str(); };
#line 176 "ValueExpressionParser.tab.cc"
        break;
      default:
        break;
    }
  *yycdebug_ << ')';
}
#endif /* ! YYDEBUG */

void
yy::ValueExpressionParser::yydestruct_ (const char* yymsg,
                         int yytype, semantic_type* yyvaluep, location_type* yylocationp)
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yymsg;
  (void) yyvaluep;
  (void) yylocationp;

  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 3: /* "\"scalarID\"" */
#line 92 "ValueExpressionParser.yy"
        { delete (yyvaluep->name); };
#line 201 "ValueExpressionParser.tab.cc"
        break;
      case 4: /* "\"vectorID\"" */
#line 92 "ValueExpressionParser.yy"
        { delete (yyvaluep->vname); };
#line 206 "ValueExpressionParser.tab.cc"
        break;
      case 6: /* "\"vector\"" */
#line 92 "ValueExpressionParser.yy"
        { delete (yyvaluep->vec); };
#line 211 "ValueExpressionParser.tab.cc"
        break;
      case 7: /* "\"expression\"" */
#line 92 "ValueExpressionParser.yy"
        { delete (yyvaluep->sfield); };
#line 216 "ValueExpressionParser.tab.cc"
        break;
      case 8: /* "\"lexpression\"" */
#line 92 "ValueExpressionParser.yy"
        { delete (yyvaluep->sfield); };
#line 221 "ValueExpressionParser.tab.cc"
        break;
      case 9: /* "\"vexpression\"" */
#line 92 "ValueExpressionParser.yy"
        { delete (yyvaluep->vfield); };
#line 226 "ValueExpressionParser.tab.cc"
        break;

      default:
        break;
    }
}

void
yy::ValueExpressionParser::yypop_ (unsigned int n)
{
  yystate_stack_.pop (n);
  yysemantic_stack_.pop (n);
  yylocation_stack_.pop (n);
}

std::ostream&
yy::ValueExpressionParser::debug_stream () const
{
  return *yycdebug_;
}

void
yy::ValueExpressionParser::set_debug_stream (std::ostream& o)
{
  yycdebug_ = &o;
}


yy::ValueExpressionParser::debug_level_type
yy::ValueExpressionParser::debug_level () const
{
  return yydebug_;
}

void
yy::ValueExpressionParser::set_debug_level (debug_level_type l)
{
  yydebug_ = l;
}


int
yy::ValueExpressionParser::parse ()
{
  /* Look-ahead and look-ahead in internal form.  */
  int yylooka;
  int yyilooka;

  /// Semantic value of the look-ahead.
  semantic_type yylval;
  /// Location of the look-ahead.
  location_type yylloc;
  /// The locations where the error started and ended.
  location yyerror_range[2];

  /// $$.
  semantic_type yyval;
  /// @$.
  location_type yyloc;

  int yyresult_;

  YYCDEBUG << "Starting parse" << std::endl;

  yynerrs_ = 0;
  yyerrstatus_ = 0;

  /* Start.  */
  yystate_ = 0;
  yylooka = yyempty_;


  /* User initialization code. */
  #line 26 "ValueExpressionParser.yy"
{
	     // Initialize the initial location.
	     //     @$.begin.filename = @$.end.filename = &driver.file;
}
/* Line 548 of yacc.c.  */
#line 306 "ValueExpressionParser.tab.cc"
  /* Initialize the stacks.  The initial state will be pushed in
     yynewstate, since the latter expects the semantical and the
     location values to have been already stored, initialize these
     stacks with a primary value.  */
  yystate_stack_ = state_stack_type (0);
  yysemantic_stack_ = semantic_stack_type (0);
  yylocation_stack_ = location_stack_type (0);
  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yylloc);

  /* New state.  */
yynewstate:
  yystate_stack_.push (yystate_);
  YYCDEBUG << "Entering state " << yystate_ << std::endl;
  goto yybackup;

  /* Backup.  */
yybackup:

  /* Try to take a decision without look-ahead.  */
  yyn_ = yypact_[yystate_];
  if (yyn_ == yypact_ninf_)
    goto yydefault;

  /* Read a look-ahead token.  */
  if (yylooka == yyempty_)
    {
      YYCDEBUG << "Reading a token: ";
      yylooka = yylex (&yylval, &yylloc, driver);
    }


  /* Convert token to internal form.  */
  if (yylooka <= yyeof_)
    {
      yylooka = yyilooka = yyeof_;
      YYCDEBUG << "Now at end of input." << std::endl;
    }
  else
    {
      yyilooka = yytranslate_ (yylooka);
      YY_SYMBOL_PRINT ("Next token is", yyilooka, &yylval, &yylloc);
    }

  /* If the proper action on seeing token ILOOKA_ is to reduce or to
     detect an error, take that action.  */
  yyn_ += yyilooka;
  if (yyn_ < 0 || yylast_ < yyn_ || yycheck_[yyn_] != yyilooka)
    goto yydefault;

  /* Reduce or error.  */
  yyn_ = yytable_[yyn_];
  if (yyn_ < 0)
    {
      if (yyn_ == yytable_ninf_)
	goto yyerrlab;
      else
	{
	  yyn_ = -yyn_;
	  goto yyreduce;
	}
    }
  else if (yyn_ == 0)
    goto yyerrlab;

  /* Accept?  */
  if (yyn_ == yyfinal_)
    goto yyacceptlab;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yyilooka, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yylooka != yyeof_)
    yylooka = yyempty_;

  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yylloc);

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus_)
    --yyerrstatus_;

  yystate_ = yyn_;
  goto yynewstate;

/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn_ = yydefact_[yystate_];
  if (yyn_ == 0)
    goto yyerrlab;
  goto yyreduce;

/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  yylen_ = yyr2_[yyn_];
  /* If LEN_ is nonzero, implement the default value of the action:
     `$$ = $1'.  Otherwise, use the top of the stack.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  */
  if (yylen_)
    yyval = yysemantic_stack_[yylen_ - 1];
  else
    yyval = yysemantic_stack_[0];

  {
    slice<location_type, location_stack_type> slice (yylocation_stack_, yylen_);
    YYLLOC_DEFAULT (yyloc, slice, yylen_);
  }
  YY_REDUCE_PRINT (yyn_);
  switch (yyn_)
    {
        case 2:
#line 100 "ValueExpressionParser.yy"
    { driver.setScalarResult((yysemantic_stack_[0].sfield));  ;}
    break;

  case 3:
#line 101 "ValueExpressionParser.yy"
    { driver.setVectorResult((yysemantic_stack_[0].vfield));  ;}
    break;

  case 4:
#line 102 "ValueExpressionParser.yy"
    { driver.setLogicalResult((yysemantic_stack_[0].sfield)); ;}
    break;

  case 5:
#line 105 "ValueExpressionParser.yy"
    { (yyval.vfield) = (yysemantic_stack_[0].vfield); ;}
    break;

  case 6:
#line 106 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) + *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 7:
#line 107 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].sfield) * *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 8:
#line 108 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) * *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 9:
#line 109 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) / *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 10:
#line 110 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) ^ *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 11:
#line 111 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(*(yysemantic_stack_[2].vfield) - *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield);;}
    break;

  case 12:
#line 112 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(-*(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 13:
#line 113 "ValueExpressionParser.yy"
    { (yyval.vfield) = (yysemantic_stack_[1].vfield); ;}
    break;

  case 14:
#line 114 "ValueExpressionParser.yy"
    { (yyval.vfield) = driver.doConditional((yysemantic_stack_[4].sfield),(yysemantic_stack_[2].vfield),(yysemantic_stack_[0].vfield),driver.makeVectorField(Foam::vector())); delete (yysemantic_stack_[4].sfield); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield); ;}
    break;

  case 15:
#line 115 "ValueExpressionParser.yy"
    { (yyval.vfield) = driver.makePositionField(); ;}
    break;

  case 16:
#line 116 "ValueExpressionParser.yy"
    { (yyval.vfield) = new Foam::volVectorField(Foam::fvc::grad(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 17:
#line 117 "ValueExpressionParser.yy"
    {
            (yyval.vfield)=driver.getVectorField(*(yysemantic_stack_[0].vname));
                    ;}
    break;

  case 18:
#line 122 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField((yysemantic_stack_[0].val)); ;}
    break;

  case 19:
#line 123 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) + *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 20:
#line 124 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) - *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 21:
#line 125 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) * *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 22:
#line 126 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].sfield) / *(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 23:
#line 127 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::pow(*(yysemantic_stack_[3].sfield), (yysemantic_stack_[1].val))); delete (yysemantic_stack_[3].sfield); ;}
    break;

  case 24:
#line 128 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::log(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 25:
#line 129 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::exp(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 26:
#line 130 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(*(yysemantic_stack_[2].vfield) & *(yysemantic_stack_[0].vfield)); delete (yysemantic_stack_[2].vfield); delete (yysemantic_stack_[0].vfield);;}
    break;

  case 27:
#line 131 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(-*(yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 28:
#line 132 "ValueExpressionParser.yy"
    { (yyval.sfield) = (yysemantic_stack_[1].sfield); ;}
    break;

  case 29:
#line 133 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sqr(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 30:
#line 134 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sqrt(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 31:
#line 135 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::sin(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 32:
#line 136 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::cos(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 33:
#line 137 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::tan(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 34:
#line 138 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(Foam::min(*(yysemantic_stack_[1].sfield)).value()); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 35:
#line 139 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(Foam::max(*(yysemantic_stack_[1].sfield)).value()); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 36:
#line 140 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::mag(*(yysemantic_stack_[1].sfield))); delete (yysemantic_stack_[1].sfield); ;}
    break;

  case 37:
#line 141 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::mag(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 38:
#line 142 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField(Foam::fvc::div(*(yysemantic_stack_[1].vfield))); delete (yysemantic_stack_[1].vfield); ;}
    break;

  case 39:
#line 143 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[2].vfield)->component(0)); delete (yysemantic_stack_[2].vfield); ;}
    break;

  case 40:
#line 144 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[2].vfield)->component(1)); delete (yysemantic_stack_[2].vfield); ;}
    break;

  case 41:
#line 145 "ValueExpressionParser.yy"
    { (yyval.sfield) = new Foam::volScalarField((yysemantic_stack_[2].vfield)->component(2)); delete (yysemantic_stack_[2].vfield); ;}
    break;

  case 42:
#line 146 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doConditional((yysemantic_stack_[4].sfield),(yysemantic_stack_[2].sfield),(yysemantic_stack_[0].sfield),driver.makeScalarField(0.)); delete (yysemantic_stack_[4].sfield); delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 43:
#line 147 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(M_PI); ;}
    break;

  case 44:
#line 148 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeDistanceField(); ;}
    break;

  case 45:
#line 149 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeRandomField(); ;}
    break;

  case 46:
#line 150 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeGaussRandomField(); ;}
    break;

  case 47:
#line 151 "ValueExpressionParser.yy"
    { 
            (yyval.sfield)=driver.getScalarField(*(yysemantic_stack_[0].name));
				;}
    break;

  case 48:
#line 156 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(1); ;}
    break;

  case 49:
#line 157 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.makeScalarField(0); ;}
    break;

  case 50:
#line 158 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::less<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 51:
#line 159 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::greater<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 52:
#line 160 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::less_equal<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 53:
#line 161 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::greater_equal<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 54:
#line 162 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::equal_to<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 55:
#line 163 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doCompare((yysemantic_stack_[2].sfield),std::not_equal_to<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 56:
#line 164 "ValueExpressionParser.yy"
    { (yyval.sfield) = (yysemantic_stack_[1].sfield); ;}
    break;

  case 57:
#line 165 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalOp((yysemantic_stack_[2].sfield),std::logical_and<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 58:
#line 166 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalOp((yysemantic_stack_[2].sfield),std::logical_or<Foam::scalar>(),(yysemantic_stack_[0].sfield));  delete (yysemantic_stack_[2].sfield); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 59:
#line 167 "ValueExpressionParser.yy"
    { (yyval.sfield) = driver.doLogicalNot((yysemantic_stack_[0].sfield)); delete (yysemantic_stack_[0].sfield); ;}
    break;

  case 60:
#line 170 "ValueExpressionParser.yy"
    {     (yyval.vfield) = driver.makeVectorField((yysemantic_stack_[5].sfield),(yysemantic_stack_[3].sfield),(yysemantic_stack_[1].sfield));  delete (yysemantic_stack_[5].sfield); delete (yysemantic_stack_[3].sfield); delete (yysemantic_stack_[1].sfield);}
    break;


      default: break;
    }

/* Line 676 of lalr1.cc.  */
#line 730 "ValueExpressionParser.tab.cc"

  yypop_ (yylen_);

  YY_STACK_PRINT ();

  yysemantic_stack_.push (yyval);
  yylocation_stack_.push (yyloc);

  /* Shift the result of the reduction.  */
  yyn_ = yyr1_[yyn_];
  yystate_ = yypgoto_[yyn_ - yyntokens_] + yystate_stack_[0];
  if (0 <= yystate_ && yystate_ <= yylast_
      && yycheck_[yystate_] == yystate_stack_[0])
    yystate_ = yytable_[yystate_];
  else
    yystate_ = yydefgoto_[yyn_ - yyntokens_];
  goto yynewstate;

/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus_)
    {
      ++yynerrs_;
      error (yylloc, yysyntax_error_ (YYERROR_VERBOSE_IF (yyilooka)));
    }

  yyerror_range[0] = yylloc;
  if (yyerrstatus_ == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yylooka <= yyeof_)
        {
	  /* Return failure if at end of input.  */
	  if (yylooka == yyeof_)
	    YYABORT;
        }
      else
        {
          yydestruct_ ("Error: discarding", yyilooka, &yylval, &yylloc);
          yylooka = yyempty_;
        }
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (false)
    goto yyerrorlab;

  yyerror_range[0] = yylocation_stack_[yylen_ - 1];
  yypop_ (yylen_);
  yystate_ = yystate_stack_[0];
  goto yyerrlab1;

/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn_ = yypact_[yystate_];
      if (yyn_ != yypact_ninf_)
	{
	  yyn_ += yyterror_;
	  if (0 <= yyn_ && yyn_ <= yylast_ && yycheck_[yyn_] == yyterror_)
	    {
	      yyn_ = yytable_[yyn_];
	      if (0 < yyn_)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yystate_stack_.height () == 1)
	YYABORT;

      yyerror_range[0] = yylocation_stack_[0];
      yydestruct_ ("Error: popping",
                   yystos_[yystate_],
                   &yysemantic_stack_[0], &yylocation_stack_[0]);
      yypop_ ();
      yystate_ = yystate_stack_[0];
      YY_STACK_PRINT ();
    }

  if (yyn_ == yyfinal_)
    goto yyacceptlab;

  yyerror_range[1] = yylloc;
  // Using YYLLOC is tempting, but would change the location of
  // the look-ahead.  YYLOC is available though.
  YYLLOC_DEFAULT (yyloc, yyerror_range - 1, 2);
  yysemantic_stack_.push (yylval);
  yylocation_stack_.push (yyloc);

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos_[yyn_],
		   &yysemantic_stack_[0], &yylocation_stack_[0]);

  yystate_ = yyn_;
  goto yynewstate;

  /* Accept.  */
yyacceptlab:
  yyresult_ = 0;
  goto yyreturn;

  /* Abort.  */
yyabortlab:
  yyresult_ = 1;
  goto yyreturn;

yyreturn:
  if (yylooka != yyeof_ && yylooka != yyempty_)
    yydestruct_ ("Cleanup: discarding lookahead", yyilooka, &yylval, &yylloc);

  while (yystate_stack_.height () != 1)
    {
      yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
      yypop_ ();
    }

  return yyresult_;
}

// Generate an error message.
std::string
yy::ValueExpressionParser::yysyntax_error_ (YYERROR_VERBOSE_IF (int tok))
{
  std::string res;
#if YYERROR_VERBOSE
  yyn_ = yypact_[yystate_];
  if (yypact_ninf_ < yyn_ && yyn_ < yylast_)
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  */
      int yyxbegin = yyn_ < 0 ? -yyn_ : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = yylast_ - yyn_;
      int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
      int count = 0;
      for (int x = yyxbegin; x < yyxend; ++x)
        if (yycheck_[x + yyn_] == x && x != yyterror_)
          ++count;

      // FIXME: This method of building the message is not compatible
      // with internationalization.  It should work like yacc.c does it.
      // That is, first build a string that looks like this:
      // "syntax error, unexpected %s or %s or %s"
      // Then, invoke YY_ on this string.
      // Finally, use the string as a format to output
      // yytname_[tok], etc.
      // Until this gets fixed, this message appears in English only.
      res = "syntax error, unexpected ";
      res += yytnamerr_ (yytname_[tok]);
      if (count < 5)
        {
          count = 0;
          for (int x = yyxbegin; x < yyxend; ++x)
            if (yycheck_[x + yyn_] == x && x != yyterror_)
              {
                res += (!count++) ? ", expecting " : " or ";
                res += yytnamerr_ (yytname_[x]);
              }
        }
    }
  else
#endif
    res = YY_("syntax error");
  return res;
}


/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
const signed char yy::ValueExpressionParser::yypact_ninf_ = -46;
const short int
yy::ValueExpressionParser::yypact_[] =
{
     141,   -46,   -46,   -46,   -45,   -46,   -46,   -46,   -26,   -23,
       3,     5,     6,    39,    40,    44,    45,    46,    48,    49,
      60,    61,    63,    64,    68,   141,   141,   141,    20,   392,
     388,     1,   -46,   141,    15,    77,    96,   132,   141,   141,
     141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
     141,    82,   -46,     1,    16,   137,   -30,   392,   388,   -46,
     -46,   141,   141,   141,   141,   141,   141,   -17,   141,   141,
     141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   -29,   -46,   -46,   -46,   -46,    42,   163,    65,   180,
     197,   371,   214,   231,   248,   265,   282,   299,   316,   333,
     -46,   -46,   -46,   -27,   -27,   -46,   -46,    82,    82,   -46,
     -46,   -46,   388,   388,   388,   388,   388,   388,   -13,   -13,
      82,   -46,   -46,    80,   367,    17,   -46,   141,   -46,   -46,
      47,   -46,   -46,   -46,   -46,   -46,   -46,   -46,   -46,   -46,
     -46,   -46,   141,   141,    98,   133,   392,   388,   141,   -46,
     350,   -46
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error.  */
const unsigned char
yy::ValueExpressionParser::yydefact_[] =
{
       0,    47,    17,    18,     0,    48,    49,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       2,     4,     5,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,    27,     0,     0,     0,     0,     0,     0,    59,
       1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    15,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      13,    28,    56,    11,     6,     8,     9,    26,    10,    39,
      40,    41,    55,    54,    50,    51,    53,    52,    20,    19,
       7,    21,    22,     0,     0,    58,    57,     0,    38,    16,
       0,    24,    25,    37,    36,    31,    32,    33,    34,    35,
      29,    30,     0,     0,     0,     0,    14,    42,     0,    23,
       0,    60
};

/* YYPGOTO[NTERM-NUM].  */
const signed char
yy::ValueExpressionParser::yypgoto_[] =
{
     -46,   -46,    54,     0,     2,   -46
};

/* YYDEFGOTO[NTERM-NUM].  */
const signed char
yy::ValueExpressionParser::yydefgoto_[] =
{
      -1,    28,    57,    58,    53,    32
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.  */
const signed char yy::ValueExpressionParser::yytable_ninf_ = -1;
const unsigned char
yy::ValueExpressionParser::yytable_[] =
{
      30,    78,    31,    79,    80,    33,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    63,    64,    65,    66,
      60,   102,    67,   127,    34,    52,    55,    35,    56,    59,
      76,    77,    78,    81,    79,    80,   109,   110,   111,    87,
      88,    89,    90,    92,    93,    94,    95,    96,    97,    98,
      99,    80,   145,    36,    29,    37,    38,    61,    62,    63,
      64,    65,    66,   105,   106,    67,    82,   100,   112,   113,
     114,   115,   116,   117,   118,   119,   121,   122,   124,    51,
      54,   125,   126,    61,    62,    63,    64,    65,    66,    39,
      40,    67,    86,   128,    41,    42,    43,    91,    44,    45,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      46,    47,   142,    48,    49,   103,   104,   130,    50,   107,
     108,    61,    62,    63,    64,    65,    66,   144,    83,    67,
     120,    67,   123,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,   147,     1,     2,     3,    84,   150,     0,
     148,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    25,    85,   149,     0,     0,     0,   101,     0,
       0,    26,     0,     0,     0,     0,   146,    27,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,     0,     0,
       0,     0,     0,     0,   129,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,     0,     0,     0,     0,     0,
       0,   131,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,     0,     0,     0,     0,     0,     0,   132,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,     0,
       0,     0,     0,     0,     0,   134,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,     0,     0,     0,     0,
       0,     0,   135,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,     0,     0,     0,     0,     0,     0,   136,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
       0,     0,     0,     0,     0,     0,   137,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,     0,     0,     0,
       0,     0,     0,   138,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,     0,     0,     0,     0,     0,     0,
     139,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,     0,     0,     0,     0,     0,     0,   140,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,     0,     0,
       0,     0,     0,     0,   141,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,     0,     0,     0,     0,   143,
       0,   151,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    61,    62,    63,    64,    65,    66,     0,     0,
      67,     0,   133,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    61,    62,    63,    64,    65,    66,     0,
       0,    67
};

/* YYCHECK.  */
const short int
yy::ValueExpressionParser::yycheck_[] =
{
       0,    31,     0,    33,    34,    50,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    43,    44,    45,    46,
       0,    51,    49,    52,    50,    25,    26,    50,    26,    27,
      43,    44,    31,    33,    33,    34,    53,    54,    55,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    34,     5,    50,     0,    50,    50,    41,    42,    43,
      44,    45,    46,    63,    64,    49,    51,    51,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    25,
      26,    79,    80,    41,    42,    43,    44,    45,    46,    50,
      50,    49,    38,    51,    50,    50,    50,    43,    50,    50,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      50,    50,    32,    50,    50,    61,    62,    52,    50,    65,
      66,    41,    42,    43,    44,    45,    46,   127,    51,    49,
      76,    49,    78,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   143,     3,     4,     5,    51,   148,    -1,
      52,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    41,    51,    51,    -1,    -1,    -1,    51,    -1,
      -1,    50,    -1,    -1,    -1,    -1,   142,    56,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    51,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    32,
      -1,    51,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    41,    42,    43,    44,    45,    46,    -1,    -1,
      49,    -1,    51,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    41,    42,    43,    44,    45,    46,    -1,
      -1,    49
};

/* STOS_[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
const unsigned char
yy::ValueExpressionParser::yystos_[] =
{
       0,     3,     4,     5,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    41,    50,    56,    58,    59,
      60,    61,    62,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    59,    60,    61,    59,    60,    61,    59,    60,    61,
       0,    41,    42,    43,    44,    45,    46,    49,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    31,    33,
      34,    60,    51,    51,    51,    51,    59,    60,    60,    60,
      60,    59,    60,    60,    60,    60,    60,    60,    60,    60,
      51,    51,    51,    59,    59,    60,    60,    59,    59,    53,
      54,    55,    60,    60,    60,    60,    60,    60,    60,    60,
      59,    60,    60,    59,    60,    61,    61,    52,    51,    51,
      52,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    32,    32,    60,     5,    59,    60,    52,    51,
      60,    51
};

#if YYDEBUG
/* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
   to YYLEX-NUM.  */
const unsigned short int
yy::ValueExpressionParser::yytoken_number_[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,    63,    58,   286,   287,   288,   289,    60,    62,   290,
     291,    45,    43,    42,    47,    38,    94,   292,   293,    46,
      40,    41,    44,   120,   121,   122,    33
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
const unsigned char
yy::ValueExpressionParser::yyr1_[] =
{
       0,    57,    58,    58,    58,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      62
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
const unsigned char
yy::ValueExpressionParser::yyr2_[] =
{
       0,     2,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     2,     3,     5,     3,     4,     1,     1,     3,
       3,     3,     3,     6,     4,     4,     3,     2,     3,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     3,
       3,     3,     5,     1,     3,     3,     3,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       8
};

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at \a yyntokens_, nonterminals. */
const char*
const yy::ValueExpressionParser::yytname_[] =
{
  "$end", "error", "$undefined", "\"scalarID\"", "\"vectorID\"",
  "\"number\"", "\"vector\"", "\"expression\"", "\"lexpression\"",
  "\"vexpression\"", "TOKEN_VECTOR", "TOKEN_TRUE", "TOKEN_FALSE",
  "TOKEN_pi", "TOKEN_rand", "TOKEN_randNormal", "TOKEN_position",
  "TOKEN_dist", "TOKEN_div", "TOKEN_grad", "TOKEN_pow", "TOKEN_log",
  "TOKEN_exp", "TOKEN_mag", "TOKEN_sin", "TOKEN_cos", "TOKEN_tan",
  "TOKEN_min", "TOKEN_max", "TOKEN_sqr", "TOKEN_sqrt", "'?'", "':'",
  "TOKEN_OR", "TOKEN_AND", "TOKEN_NEQ", "TOKEN_EQ", "'<'", "'>'",
  "TOKEN_GEQ", "TOKEN_LEQ", "'-'", "'+'", "'*'", "'/'", "'&'", "'^'",
  "TOKEN_NOT", "TOKEN_NEG", "'.'", "'('", "')'", "','", "'x'", "'y'",
  "'z'", "'!'", "$accept", "unit", "vexp", "exp", "lexp", "vector", 0
};
#endif

#if YYDEBUG
/* YYRHS -- A `-1'-separated list of the rules' RHS. */
const yy::ValueExpressionParser::rhs_number_type
yy::ValueExpressionParser::yyrhs_[] =
{
      58,     0,    -1,    60,    -1,    59,    -1,    61,    -1,    62,
      -1,    59,    42,    59,    -1,    60,    43,    59,    -1,    59,
      43,    60,    -1,    59,    44,    60,    -1,    59,    46,    59,
      -1,    59,    41,    59,    -1,    41,    59,    -1,    50,    59,
      51,    -1,    61,    31,    59,    32,    59,    -1,    16,    50,
      51,    -1,    19,    50,    60,    51,    -1,     4,    -1,     5,
      -1,    60,    42,    60,    -1,    60,    41,    60,    -1,    60,
      43,    60,    -1,    60,    44,    60,    -1,    20,    50,    60,
      52,     5,    51,    -1,    21,    50,    60,    51,    -1,    22,
      50,    60,    51,    -1,    59,    45,    59,    -1,    41,    60,
      -1,    50,    60,    51,    -1,    29,    50,    60,    51,    -1,
      30,    50,    60,    51,    -1,    24,    50,    60,    51,    -1,
      25,    50,    60,    51,    -1,    26,    50,    60,    51,    -1,
      27,    50,    60,    51,    -1,    28,    50,    60,    51,    -1,
      23,    50,    60,    51,    -1,    23,    50,    59,    51,    -1,
      18,    50,    59,    51,    -1,    59,    49,    53,    -1,    59,
      49,    54,    -1,    59,    49,    55,    -1,    61,    31,    60,
      32,    60,    -1,    13,    -1,    17,    50,    51,    -1,    14,
      50,    51,    -1,    15,    50,    51,    -1,     3,    -1,    11,
      -1,    12,    -1,    60,    37,    60,    -1,    60,    38,    60,
      -1,    60,    40,    60,    -1,    60,    39,    60,    -1,    60,
      36,    60,    -1,    60,    35,    60,    -1,    50,    61,    51,
      -1,    61,    34,    61,    -1,    61,    33,    61,    -1,    56,
      61,    -1,    10,    50,    60,    52,    60,    52,    60,    51,
      -1
};

/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
const unsigned char
yy::ValueExpressionParser::yyprhs_[] =
{
       0,     0,     3,     5,     7,     9,    11,    15,    19,    23,
      27,    31,    35,    38,    42,    48,    52,    57,    59,    61,
      65,    69,    73,    77,    84,    89,    94,    98,   101,   105,
     110,   115,   120,   125,   130,   135,   140,   145,   150,   155,
     159,   163,   167,   173,   175,   179,   183,   187,   189,   191,
     193,   197,   201,   205,   209,   213,   217,   221,   225,   229,
     232
};

/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
const unsigned char
yy::ValueExpressionParser::yyrline_[] =
{
       0,   100,   100,   101,   102,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     170
};

// Print the state stack on the debug stream.
void
yy::ValueExpressionParser::yystack_print_ ()
{
  *yycdebug_ << "Stack now";
  for (state_stack_type::const_iterator i = yystate_stack_.begin ();
       i != yystate_stack_.end (); ++i)
    *yycdebug_ << ' ' << *i;
  *yycdebug_ << std::endl;
}

// Report on the debug stream that the rule \a yyrule is going to be reduced.
void
yy::ValueExpressionParser::yyreduce_print_ (int yyrule)
{
  unsigned int yylno = yyrline_[yyrule];
  /* Print the symbols being reduced, and their result.  */
  *yycdebug_ << "Reducing stack by rule " << yyn_ - 1
             << " (line " << yylno << "), ";
  for (unsigned char i = yyprhs_[yyn_];
       0 <= yyrhs_[i]; ++i)
    *yycdebug_ << yytname_[yyrhs_[i]] << ' ';
  *yycdebug_ << "-> " << yytname_[yyr1_[yyn_]] << std::endl;
}
#endif // YYDEBUG

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
yy::ValueExpressionParser::token_number_type
yy::ValueExpressionParser::yytranslate_ (int token)
{
  static
  const token_number_type
  translate_table[] =
  {
         0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    56,     2,     2,     2,     2,    45,     2,
      50,    51,    43,    42,    52,    41,    49,    44,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    32,     2,
      37,     2,    38,    31,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    46,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      53,    54,    55,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    33,    34,    35,    36,
      39,    40,    47,    48
  };
  if ((unsigned int) token <= yyuser_token_number_max_)
    return translate_table[token];
  else
    return yyundef_token_;
}

const int yy::ValueExpressionParser::yyeof_ = 0;
const int yy::ValueExpressionParser::yylast_ = 441;
const int yy::ValueExpressionParser::yynnts_ = 6;
const int yy::ValueExpressionParser::yyempty_ = -2;
const int yy::ValueExpressionParser::yyfinal_ = 60;
const int yy::ValueExpressionParser::yyterror_ = 1;
const int yy::ValueExpressionParser::yyerrcode_ = 256;
const int yy::ValueExpressionParser::yyntokens_ = 57;

const unsigned int yy::ValueExpressionParser::yyuser_token_number_max_ = 293;
const yy::ValueExpressionParser::token_number_type yy::ValueExpressionParser::yyundef_token_ = 2;

#line 173 "ValueExpressionParser.yy"


void yy::ValueExpressionParser::error (const yy::ValueExpressionParser::location_type& l,const std::string& m)
{
     driver.error (l, m);
}

